#include "SoTerrain.h"

int trianglemain(int, OutFile*, int *, int *);

SoTerrain::~SoTerrain()
{
  delete demData;
};

void
SoTerrain::tmp_build()
{
  buildCoordinates();
  buildFaceSet();

  SoCoordinate3 *c = new SoCoordinate3;
  c->point.set1Value(0, 0, 0, 0);
  c->point.set1Value(1, size, 0, 0);
  c->point.set1Value(2, size, 0, size);
  c->point.set1Value(3, 0, 0, size);
  c->point.set1Value(4, size/2, size/2, size/2);
  addChild(c);
  
  SoIndexedFaceSet *f = new SoIndexedFaceSet;
  f->coordIndex.set1Value(0, 4);
  f->coordIndex.set1Value(1, 1);
  f->coordIndex.set1Value(2, 0);
  f->coordIndex.set1Value(3, -1);
  f->coordIndex.set1Value(4, 4);
  f->coordIndex.set1Value(5, 2);
  f->coordIndex.set1Value(6, 1);
  f->coordIndex.set1Value(7, -1);
  f->coordIndex.set1Value(8, 4);
  f->coordIndex.set1Value(9, 3);
  f->coordIndex.set1Value(10, 2);
  f->coordIndex.set1Value(11, -1);
  f->coordIndex.set1Value(12, 4);
  f->coordIndex.set1Value(13, 0);
  f->coordIndex.set1Value(14, 3);
  f->coordIndex.set1Value(15, -1);
  addChild(f);
};

void
SoTerrain::build()
{
  // Reading in data file in PGM format


// df contains two-dimensional array of elevation values

// tr will contain SoSeparator root with the whole terrain

   IVFile *tr = new IVFile();
   tr->writeInitialParams();

   info("Starting the list of nodes");

   tr->startListOfNodes();
   info("list of nodes started ");

// Mesh simplification
   
   info("initializing the mesh simp");
   Timer *mst = new Timer;
   
   //   SecDerSimplifier *ms = new SecDerSimplifier(demData, tr, dim);
   MeshSimplifier *ms = new MeshSimplifier(demData, tr, dim);
   info("simplifying mesh");
   
   ms->simplifyMesh(meshThresh);
   mst->stop("Mesh simplification time");
   
   tr->finishListOfNodes();

   info("Starting the list of faces");
   tr->startListOfFaces();

   trianglemain(ms->getNotRemovedCounter(), tr, ms->datax, ms->dataz);

// WriteTextureData(class DEM *df);
   tr->finishListOfFaces();

   delete ms;

   addChild(tr->root);

};

void SoTerrain::buildCoordinates()
{};

void SoTerrain::buildFaceSet()
{};


